//       
var allmarks = {};

//   
function docmark_add()
{
	// URL      
	//   
	var id = window.content.document.location.href;

	if (typeof(allmarks[id]) == "undefined") {
		allmarks[id] = [];
	}

	var num = allmarks[id].length;
	var label = prompt(document.getElementById("docmark-string-bundle").getFormattedString("docmarkMarkTitle", [num + 1]), "");
	if (label != null) {
		// pageXOffset, pageYOffset --   
		allmarks[id][num] = {offsetX:window.content.pageXOffset, offsetY:window.content.pageYOffset, label:label};
	}
}

//    
function docmark_generate_menu_marks(menu)
{
	//    
	docmark_remove_menu_marks(menu);

	var marks = allmarks[window.content.document.location.href];
	if (typeof(marks) == "undefined") return;

	var menuItem;

	if (marks.length != 0) {
		//   
		menuItem = document.createElement("menuseparator");
		docmark_insert_menu_item(menu, menuItem);
	} else return;

	for (var i = 0; i < marks.length; ++i) {
		var num = i + 1;
		var mark = marks[i];
		menuItem = document.createElement("menuitem");
		menuItem.setAttribute("label", num + '. ' + mark.label);
		menuItem.setAttribute("oncommand", "window.content.scrollTo(" + mark.offsetX + "," + mark.offsetY + ")");
		if (num <= 10) {
			menuItem.setAttribute("accesskey", num % 10);
		}
		docmark_insert_menu_item(menu, menuItem);
	}
}

//    
function docmark_insert_menu_item(menu, item)
{
	item.setAttribute("class", "docmark-generated-menu");
	menu.insertBefore(item, document.getElementById("docmark-separator-end"));
}

//   
function docmark_remove_menu_marks(menu)
{
	var menuItems = menu.getElementsByAttribute("class", "docmark-generated-menu");
	for (var i = 0; i < menuItems.length; ++i) {
		menu.removeChild(menuItems[i]);
	}
}
//  "About"
function docmark_about()
{
	window.openDialog("chrome://docmark/content/about.xul", "docmark-about-dialog", "centerscreen,chrome,modal");
}
